#include <windows.h>
#include <math.h>

//
//
//
//
//

#define MaxNumberOfComputations 20
#define MaxLag                  200
#define MaxArrayLength          5000

#define minVal(a, b)  (((a) < (b)) ? (a) : (b))
#define maxVal(a, b)  (((a) > (b)) ? (a) : (b))
#define absVal(a)     (((a) > 0) ? (a) : (-a))

//
//
//
//
//

double A[200][200];
double B[5000][200];
double Bn[200][5000];
double V[200][5000];
double Yn[200][5000];








//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//

bool __stdcall DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:  break;
        case DLL_PROCESS_DETACH:  break;
        case DLL_THREAD_ATTACH:   break;
        case DLL_THREAD_DETACH:   break;
    }
    return TRUE;
}

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//


int gaussSn(double At[200][200],double l,int n)
{
    int i,j,k;
    double Bt[200][200],c;

    for(i=0; i<n; i++)
    for(j=0; j<n; j++) Bt[i][j] = At[i][j];
    for(i=0; i<n; i++) Bt[i][i] = Bt[i][i]-l;

    //
    //
    //
    //
    //

    for(k=0; k<n-1; k++)
    for(i=k+1; i<n; i++)
    {
        if(Bt[k][k]==0)
        {
            for(j=0; j<n; j++)
            {
                c = Bt[j][k];
                    Bt[j][k]   = Bt[j][k+1];
                    Bt[j][k+1] = c;
            }
        }
        c = Bt[i][k]/Bt[k][k];  for (j=0; j<n; j++) Bt[i][j] = Bt[i][j]-Bt[k][j]*c;
    }

	//
	//
	//
	//
	//

    for(i=0,j=0; i<n; i++) if (Bt[i][i]<0) j++;
    return (j);
}




//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//

double gaussbisectionl(double Ar[200][200],int k,int n)
{
    double a1,b1,e1,c,maxnorm;
	int    i,j;

	for (i=0,maxnorm=0; i<n; i++)
	{
        for(j=0,c=0; j<n; j++) c = c+Ar[i][j];
        if(maxnorm<c)
           maxnorm=c;
	}

	//
	//
	//
	//
	//

	a1=0.0;
	b1=maxnorm*10.0;
	e1=maxnorm*0.00000001;
	while (absVal(b1-a1)>e1)
	{
		c = (a1+b1)*0.5;
  		if (gaussSn(Ar,c,n)<k)
        		a1=c;
  		else	b1=c;
	}
   return ((a1+b1)*0.5);
}


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//

void svector(double At[200][200],double l,int n,double* Vt)
{
	int i,j,k;
	double Bt[200][200],c;

    for (i=0; i<n; i++)
    for (j=0; j<n; j++) Bt[i][j] = At[i][j];
	for (i=0; i<n; i++) Bt[i][i] = Bt[i][i]-l;

	//
	//
	//
	//
	//

	for (k=0; k<n-1; k++)
	for (i=k+1; i<n; i++)
	{
        if (Bt[k][k]==0)
		{
			for (j=0; j<n; j++)
			{
				c = Bt[j][k];
				    Bt[j][k] = Bt[j][k+1];
				    Bt[j][k+1]= c;
			}
        }
		c = Bt[i][k]/Bt[k][k]; for (j=0; j<n; j++) Bt[i][j]=Bt[i][j]-Bt[k][j]*c;
	}

	//
	//
	//
	//
	//

	Vt[n-1]=1;
	for (i=n-2, c=1.0; i>=0; i--)
	{
		for (j=i, Vt[i]=0; j<n; j++) Vt[i] = Vt[i]-Bt[i][j] * Vt[j];
		                             Vt[i] = Vt[i]/Bt[i][i];
		c = c+Vt[i]*Vt[i];
	}
	c = sqrt(c); for(i=0; i<n; i++) Vt[i]= Vt[i]/c;
}



//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//


__declspec(dllexport) void __stdcall fastSingular(const double *X, int n, int l, int s, double *Y)
//void fastSingular(const double *X, int n, int l, int s, double *Y)
{
    double Vtemp[200];
	int m,k,i,j,i1;

	//
	//
	//
	//
	//

		n  = minVal(MaxArrayLength,n);
		l  = minVal(MaxLag,l);
		s  = minVal(MaxNumberOfComputations,s);

		if(s>l) s=l;
				k=n-l+1;
					int lp = minVal(l,k);
					int kp = maxVal(l,k);

	//
	//
	//
	//
	//

    for (i=0; i<lp; i++)
    for (j=0; j<lp; j++)
    for (A[i][j]=0, m=0; m<kp; m++)
    {
        A[i][j] = A[i][j]+X[i+m]*X[m+j];
        B[m][j] = X[m+j];
    }


	//
	//
	//
	//
	//

	for (i=0; i<s; i++)
    {
		double ls = gaussbisectionl(A,lp-i,l);
                    svector(A,ls,lp,Vtemp);
		for( j=0; j<lp; j++) V[i][j]=Vtemp[j];
	}

	//
	//
	//
	//
	//

	for (i1=0; i1<s; i1++)
	{
		for (i=0; i<kp; i++) for (Yn[i1][i]=0, j=0; j<lp; j++) Yn[i1][i] = Yn[i1][i]+B[i][j]*V[i1][j];
		for (i=0; i<lp; i++) for (             j=0; j<kp; j++) Bn[i][j]  = V[i1][i]*Yn[i1][j];
   		for (i=0; i<n; i++)
		{
			Yn[i1][i] = 0;
            if (i<(lp-1)) { for (j=0;      j<=i;    j++) Yn[i1][i] = Yn[i1][i]+Bn[j][i-j];  Yn[i1][i] = Yn[i1][i]/(i+1);  continue; }
            if (i>(kp-1)) { for (j=i-kp+1; j<=n-kp; j++) Yn[i1][i] = Yn[i1][i]+Bn[j][i-j];  Yn[i1][i] = Yn[i1][i]/(n-i);  continue; }
			                for (j=0;      j<lp;    j++) Yn[i1][i] = Yn[i1][i]+Bn[j][i-j];  Yn[i1][i] = Yn[i1][i]/lp;
        }
    }

	//
	//
	//
	//
	//

	for(i=0; i<n; i++)
	for(j=0, Y[i]=0; j<s; j++) Y[i] = Y[i]+Yn[j][i];
}
